include "GenericPassengerStation.gs"
  

class Station isclass GenericPassengerStation
{

  // Controls where the train stops

  bool TriggerSupportsMassStoppedLoad(Vehicle vehicle, string triggerName)
  {
    Interface.Log("TriggerSupportsMassStoppedLoad called with triggerName " + triggerName);
    bool vehicleToTrain = vehicle.GetDirectionRelativeToTrain();
    int lengthOfTrain = vehicle.GetMyTrain().GetVehicles().size();

    // BEWARE! GROSS HACK ALERT: Hardcoded to match my naming scheme for triggers...
    int platformnumber = Str.ToInt(triggerName[1,2]);
    int triggerNumber = Str.ToInt(triggerName[8,10]);

    // AI case, control the stopping point

    // BEWARE! GROSS HACK ALERT: Assumes that the triggers are laid in rising
    // numerical order along the direction of the track

    int direction = vehicle.GetRelationToTrack(me, "track_" + platformnumber);
    if (!vehicleToTrain) {
      direction = -direction;
    }

    if(platformnumber == 3) {
      // plat 3 is a bay - stop when you get to the end
      if(triggerNumber == 1) { 
        return true;
      }

    } else {
      // catchall at the "end" of the platform
      if ((direction == Vehicle.DIRECTION_FORWARD and triggerNumber > 4) or
          (direction == Vehicle.DIRECTION_BACKWARD and triggerNumber < 2)) {
        return true;
      }

      // 2, 3 & 4 car stop
      if(lengthOfTrain < 5 and ((direction == Vehicle.DIRECTION_FORWARD and triggerNumber > 3) or
                                (direction == Vehicle.DIRECTION_BACKWARD and triggerNumber < 3))) {
        return true;
      }
    }

    // manual case - the train has been stopped anywhere along the platform

    if (vehicle.GetMyTrain().IsStopped()) {
      Interface.Log("Train is stopped");
      return true;
    }

    return false;
  }


  // controls which side the doors open on
  // BEWARE! GROSS HACK ALERT: assumes track laid with platform on left side
  // this will be true for all my stations, as my 3rd rail track requires that too...

  void GetTrackAndSide(Vehicle vehicle, string triggerName, TrackLoadInfo retInfo) {

    // BEWARE! GROSS HACK ALERT: Hardcoded to match my naming scheme for triggers...
    int platformnumber = Str.ToInt(triggerName[1,2]);

    retInfo.trackName = "track_" + platformnumber;
    retInfo.trainLeftSide = (vehicle.GetRelationToTrack(me, retInfo.trackName) != Vehicle.DIRECTION_BACKWARD) == vehicle.GetDirectionRelativeToTrain();
    retInfo.platformIndex = platformnumber - 1;
  }

  public void Init(void)
  {
    inherited();

    Interface.Log("Init called");

    // number of platforms?
    InitPassengerStation(3);

    Interface.Log("Calling StationMain...");
    
    StationMain();
  }



  public void AppendDriverDestinations(string[] destNames, string[] destTracks)
  {
    StringTable stringTable = GetAsset().GetStringTable();
    int i;
    for (i = 1; i <= 3; i++) {

      destNames[destNames.size()] = stringTable.GetString("platform") + " " + i;
      destTracks[destTracks.size()] = "track_" + i;

    }
  }
	
};

